"use strict";function _defineProperty(t,r,e){return r in t?Object.defineProperty(t,r,{value:e,enumerable:!0,configurable:!0,writable:!0}):t[r]=e,t}class Color{constructor({color:t=[0,0,0],type:r="rgb",precision:e=3,capitalize:o=!0}={color:[0,0,0],type:"rgb",precision:3,capitalize:!0}){this.updateColor(t,r),this.precision=e,this.capitalize=o}updateColor(t,r="rgb"){let e;if("string"!=typeof r)throw new TypeError("Parameter 2 must be of type string.");if(r=r.toLowerCase(),!Color.validTypes.includes(r))throw new TypeError(`Parameter 2 '${r}' is not a valid type.`);switch(r){case"hsl":e=Color.hslToRgb(t);break;case"hex":e=Color.hexToRgb(t);break;case"xyz":e=Color.xyzToRgb(t);break;case"lab":e=Color.xyzToRgb(Color.labToXyz(t));break;case"lchab":e=Color.xyzToRgb(Color.labToXyz(Color.lchABToLab(t)));break;case"rgb":case"default":t=(t=(t=t.map(t=>Math.min(255,t))).map(t=>Math.max(0,t))).map(Math.round),this._rgb=t,this._hsl=Color.rgbToHsl(this._rgb),this._hex=Color.rgbToHex(this._rgb),this._xyz=Color.rgbToXyz(this._rgb),this._lab=Color.xyzToLab(this._xyz),this._lchab=Color.labToLCHab(this._lab)}"rgb"!==r&&this.updateColor(e,"rgb")}get rgb(){return this._rgb}get rgbString(){const t="RGB("+this.rgb.join(", ")+")";return this.capitalize?t.toUpperCase():t.toLowerCase()}set rgb(t){this.updateColor(t,"rgb")}get hsl(){return this._hsl}get hslString(){const t="HSL("+this.hsl.map(t=>t.toFixed(this.precision)).join(", ")+")";return this.capitalize?t.toUpperCase():t.toLowerCase()}set hsl(t){this.updateColor(t,"hsl")}get hex(){return this._hex}get hexString(){const t=this._hex;return this.capitalize?t.toUpperCase():t.toLowerCase()}set hex(t){this.updateColor(t,"hex")}get xyz(){return this._xyz}get xyzString(){const t="XYZ("+this.xyz.map(t=>t.toFixed(this.precision)).join(", ")+")";return this.capitalize?t.toUpperCase():t.toLowerCase()}set xyz(t){this.updateColor(t,"xyz")}get lab(){return this._lab}get labString(){const t="LAB("+this.lab.map(t=>t.toFixed(this.precision)).join(", ")+")";return this.capitalize?t.toUpperCase():t.toLowerCase()}set lab(t){this.updateColor(t,"lab")}get lchab(){return this._lchab}get lchabString(){let t=this.lchab.map(t=>t.toFixed(this.precision));return this.capitalize?"LCHab("+t.join(", ")+")":"lchAB("+t.join(", ")+")"}set lchab(t){this.updateColor(t,"lchab")}static rgbToHsl(t){const r=t[0]/255,e=t[1]/255,o=t[2]/255,a=Math.max(r,e,o),i=Math.min(r,e,o);let s=(a+i)/2,n=0,l=0;return a!==i&&(n=s<.5?(a-i)/(a+i):(a-i)/(2-a-i),l=r===a?(e-o)/(a-i):e===a?2+(o-r)/(a-i):4+(r-e)/(a-i)),(l*=60)<0&&(l+=360),[l,n*=100,s*=100]}static hslToRgb(t){let r,e,o,a,i,s,n=t[0],l=t[1],h=t[2];return isFinite(n)||(n=0),isFinite(l)||(l=0),isFinite(h)||(h=0),(n/=60)<0&&(n=6- -n%6),n%=6,l=Math.max(0,Math.min(1,l/100)),h=Math.max(0,Math.min(1,h/100)),s=(i=(1-Math.abs(2*h-1))*l)*(1-Math.abs(n%2-1)),n<1?(r=i,e=s,o=0):n<2?(r=s,e=i,o=0):n<3?(r=0,e=i,o=s):n<4?(r=0,e=s,o=i):n<5?(r=s,e=0,o=i):(r=i,e=0,o=s),a=h-i/2,[r=Math.round(255*(r+a)),e=Math.round(255*(e+a)),o=Math.round(255*(o+a))]}static rgbToHex(t){const r=t[0],e=t[1],o=t[2];let a=function(t){let r=t.toString(16);return 1===r.length?"0"+r:r};return"#"+a(r)+a(e)+a(o)}static hexToRgb(t){t=t.replace(/^#?([a-f\d])([a-f\d])([a-f\d])$/i,function(t,r,e,o){return r+r+e+e+o+o});let r=/^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(t);return r?[parseInt(r[1],16),parseInt(r[2],16),parseInt(r[3],16)]:null}static rgbToXyz(t){let r=t[0]/255,e=t[1]/255,o=t[2]/255,a=t=>t<=.04045?t/12.92:Math.pow((t+.055)/1.055,2.4),i=a(r),s=a(e),n=a(o);return[100*(.4124564*i+.3575761*s+.1804375*n),100*(.2126729*i+.7151522*s+.072175*n),100*(.0193339*i+.119192*s+.9503041*n)]}static xyzToRgb(t){let r=t[0]/100,e=t[1]/100,o=t[2]/100,a=-.969266*r+1.8760108*e+.041556*o,i=.0556434*r+-.2040259*e+1.0572252*o,s=t=>t<=.0031308?12.92*t:1.055*Math.pow(t,1/2.4)-.055,n=s(3.2404542*r-1.5371385*e-.4985314*o),l=s(a),h=s(i);return[Math.round(255*n),Math.round(255*l),Math.round(255*h)]}static xyzToLab(t){let r=[95.04,100,108.884],e=t[0]/r[0],o=t[1]/r[1],a=t[2]/r[2],i=t=>t>216/24389?Math.pow(t,1/3):(24389/27*t+16)/116,s=i(e),n=i(o);return[116*n-16,500*(s-n),200*(n-i(a))]}static labToXyz(t){let r=t[0],e=t[1],o=[95.04,100,108.884],a=216/24389,i=24389/27,s=(r+16)/116,n=s-t[2]/200,l=e/500+s,h=Math.pow(l,3)>a?Math.pow(l,3):(116*l-16)/i,p=r>8?Math.pow((r+16)/116,3):r/i,c=Math.pow(n,3)>a?Math.pow(n,3):(116*n-16)/i;return[h*o[0],p*o[1],c*o[2]]}static labToLCHab(t){let r=t[1],e=t[2],o=Math.sqrt(r*r+e*e),a=Math.atan2(e,r)>=0?Math.atan2(e,r)/Math.PI*180:Math.atan2(e,r)/Math.PI*180+360;return[t[0],o,a]}static lchABToLab(t){let r=t[1],e=t[2],o=r*Math.cos(e/180*Math.PI),a=r*Math.sin(e/180*Math.PI);return[t[0],o,a]}static luminance(t,r="rgb"){if("string"!=typeof r)throw new TypeError("Parameter 2 must be of type string.");if(r=r.toLowerCase(),!Color.validTypes.includes(r))throw new TypeError(`Parameter 2 '${r}' is not a valid type.`);"rgb"!==r&&(t=new Color({color:t,type:r}).rgb);for(let r=0;r<t.length;r++)t[r]/=255,t[r]<.03928?t[r]/=12.92:t[r]=Math.pow((t[r]+.055)/1.055,2.4);return.2126*t[0]+.7152*t[1]+.0722*t[2]}static random(){return new Color({color:[255,255,255].map(t=>t*Math.random())})}static randomOfType(t="rgb"){if("string"!=typeof t)throw new TypeError("Parameter 1 must be of type string.");if(t=t.toLowerCase(),!Color.validTypes.includes(t))throw new TypeError(`Parameter 1 '${t}' is not a valid type.`);return Color.random()[t]}static randomOfTypeFormatted(t="rgb",r=!0,e=3){if("string"!=typeof t)throw new TypeError("Parameter 1 must be of type string.");if(t=t.toLowerCase(),!Color.validTypes.includes(t))throw new TypeError(`Parameter 1 '${t}' is not a valid type.`);const o=Color.random();return o.capitalize=r,o.precision=e,o[t+"String"]}static contrastTextColor(t,r="rgb"){if("string"!=typeof r)throw new TypeError("Parameter 2 must be of type string.");if(r=r.toLowerCase(),!Color.validTypes.includes(r))throw new TypeError(`Parameter 2 '${r}' is not a valid type.`);return Color.contrastRatio(new Color({color:[255,255,255]}),new Color({color:t,type:r}))>Color.contrastRatio(new Color({color:[0,0,0]}),new Color({color:t,type:r}))?"#FFFFFF":"#000000"}static contrastRatio(t,r){if(!(t instanceof Color))throw new TypeError("Parameter 1 must be of type Color.");if(!(r instanceof Color))throw new TypeError("Parameter 2 must be of type Color.");const e=Color.luminance(t.rgb)+.05,o=Color.luminance(r.rgb)+.05;return o>e?o/e:e/o}}_defineProperty(Color,"validTypes",["rgb","hex","hsl","xyz","lab","lchab"]);